diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index 765af2463..a32fcd029 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -553,37 +516,37 @@ public class Gui
 
                     for (int i = 0; i < repeatsX; i++) {
                         for (int j = 0; j < repeatsY; j++) {
-                            drawIconTextureDouble(
+                            addIconTextureDouble(t,
                                 x + properties.width * i, y + properties.height * j,
                                 x + properties.width * (i + 1), y + properties.height * (j + 1),
-                                0, 0,
+                                epW, epH,
                                 properties.width * uScale, properties.height * vScale,
                                 coordinate);
                         }
                     }
 
                     for (int j = 0; j < repeatsY; j++) {
-                        drawIconTextureDouble(
+                        addIconTextureDouble(t,
                             x + properties.width * repeatsX, y + properties.height * j,
                             x + properties.width * repeatsX + remainderX, y + properties.height * (j + 1),
-                            0, 0,
+                            epW, epH,
                             remainderX * uScale, properties.height * vScale,
                             coordinate);
                     }
 
                     for (int i = 0; i < repeatsX; i++) {
-                        drawIconTextureDouble(
+                        addIconTextureDouble(t,
                             x + properties.width * i, y + properties.height * repeatsY,
                             x + properties.width * (i + 1), y + properties.height * repeatsY + remainderY,
-                            0, 0,
+                            epW, epH,
                             properties.width * uScale, remainderY * vScale,
                             coordinate);
                     }
 
-                    drawIconTextureDouble(
+                    addIconTextureDouble(t,
                         x + properties.width * repeatsX, y + properties.height * repeatsY,
                         x + properties.width * repeatsX + remainderX, y + properties.height * repeatsY + remainderY,
-                        0, 0,
+                        epW, epH,
                         remainderX * uScale, remainderY * vScale,
                         coordinate);
 
@@ -611,7 +574,7 @@ public class Gui
 
                     { // Inner
                         if (properties.stretchInner) { // Stretch Inner // TODO implement
-                            drawIconTextureDouble(
+                            addIconTextureDouble(t,
                                 x + innerLeft, y + innerTop,
                                 x + innerLeft + width - properties.border.right - properties.border.left, y + innerTop + height - properties.border.bottom - properties.border.top,
                                 innerLeft * uScale, innerTop * vScale,
@@ -619,7 +582,7 @@ public class Gui
                                 coordinate);
                         } else {
                             for (int j = 0; j < repeatsY; j++) {
-                                drawIconTextureDouble(
+                                addIconTextureDouble(t,
                                     x + innerLeft + repeatsX * innerWidth, y + innerTop + j * innerHeight,
                                     x + innerLeft + repeatsX * innerWidth + remainderX, y + innerTop + j * innerHeight + innerHeight,
                                     innerLeft * uScale, innerTop * vScale,
@@ -628,13 +591,13 @@ public class Gui
                             }
 
                             for (int i = 0; i < repeatsX; i++) {
-                                drawIconTextureDouble(
+                                addIconTextureDouble(t,
                                     x + innerLeft + i * innerWidth, y + innerTop + repeatsY * innerHeight,
                                     x + innerLeft + i * innerWidth + innerWidth, y + innerTop + repeatsY * innerHeight + remainderY,
                                     innerLeft * uScale, innerTop * vScale,
                                     (innerLeft + innerWidth) * uScale, (innerTop + remainderY) * vScale, coordinate);
                             }
-                            drawIconTextureDouble(
+                            addIconTextureDouble(t,
                                 x + innerLeft + repeatsX * innerWidth, y + innerTop + repeatsY * innerHeight,
                                 x + innerLeft + repeatsX * innerWidth + remainderX, y + innerTop + repeatsY * innerHeight + remainderY,
                                 innerLeft * uScale, innerTop * vScale,
@@ -644,7 +607,7 @@ public class Gui
                                 for (int j = 0; j < repeatsY; j++) {
                                     final double xMin = (x + innerLeft) + i * innerWidth;
                                     final double yMin = (y + innerTop) + j * innerHeight;
-                                    drawIconTextureDouble(
+                                    addIconTextureDouble(t,
                                         xMin, yMin,
                                         xMin + innerWidth, yMin + innerHeight,
                                         innerLeft * uScale, innerTop * vScale,
@@ -657,44 +620,44 @@ public class Gui
 
                     { // Left Right
                         for (int i = 0; i < repeatsY; i++) {
-                            drawIconTextureDouble(
+                            addIconTextureDouble(t,
                                 x, y + innerTop + i * innerHeight,
                                 x + innerLeft, y + innerTop + i * innerHeight + innerHeight,
-                                0, innerTop * vScale,
+                                epW, innerTop * vScale,
                                 innerLeft * uScale, (innerTop + innerHeight) * vScale,
                                 coordinate);
 
-                            drawIconTextureDouble(
+                            addIconTextureDouble(t,
                                 x + width - properties.border.right, y + innerTop + i * innerHeight,
                                 x + width, y + innerTop + i * innerHeight + innerHeight,
-                                innerRight * uScale, innerTop * vScale,
+                                innerRight * uScale - epW, innerTop * vScale,
                                 (innerRight + properties.border.right) * uScale, (innerTop + innerHeight) * vScale,
                                 coordinate);
                         }
 
-                        drawIconTextureDouble(
+                        addIconTextureDouble(t,
                             x, y + innerTop + repeatsY * innerHeight,
                             x + innerLeft, y + innerTop + repeatsY * innerHeight + remainderY,
-                            0, innerTop * vScale,
+                            epW, innerTop * vScale,
                             innerLeft * uScale, (innerTop + remainderY) * vScale,
                             coordinate);
 
-                        drawIconTextureDouble(
+                        addIconTextureDouble(t,
                             x + width - properties.border.right, y + innerTop + repeatsY * innerHeight,
                             x + width, y + innerTop + repeatsY * innerHeight + remainderY,
-                            innerRight * uScale, innerTop * vScale,
+                            innerRight * uScale - epW, innerTop * vScale,
                             (innerRight + properties.border.right) * uScale, (innerTop + remainderY) * vScale,
                             coordinate);
                     }
                     { // Top Bottom
                         for (int i = 0; i < repeatsX; i++) {
-                            drawIconTextureDouble(x + innerLeft + i * innerWidth, y,
+                            addIconTextureDouble(t, x + innerLeft + i * innerWidth, y,
                                 x + innerLeft + i * innerWidth + innerWidth, y + properties.border.top,
-                                innerLeft * uScale, 0,
+                                innerLeft * uScale, epH,
                                 (innerLeft + innerWidth) * uScale, properties.border.top * vScale,
                                 coordinate);
 
-                            drawIconTextureDouble(
+                            addIconTextureDouble(t,
                                 x + innerLeft + i * innerWidth, y + height - properties.border.bottom,
                                 x + innerLeft + i * innerWidth + innerWidth, y + height,
                                 innerLeft * uScale, innerBottom * vScale,
@@ -702,14 +665,14 @@ public class Gui
                                 coordinate);
                         }
 
-                        drawIconTextureDouble(
+                        addIconTextureDouble(t,
                             x + innerLeft + repeatsX * innerWidth, y,
                             x + innerLeft + repeatsX * innerWidth + remainderX, y + properties.border.top,
-                            innerLeft * uScale, 0,
+                            innerLeft * uScale, epH,
                             (innerLeft + remainderX) * uScale, properties.border.top * vScale,
                             coordinate);
 
-                        drawIconTextureDouble(
+                        addIconTextureDouble(t,
                             x + innerLeft + repeatsX * innerWidth, y + height - properties.border.bottom,
                             x + innerLeft + repeatsX * innerWidth + remainderX, y + height,
                             innerLeft * uScale, innerBottom * vScale,
@@ -717,23 +680,23 @@ public class Gui
                             coordinate);
                     }
 
-                    drawIconTextureDouble(
+                    addIconTextureDouble(t,
                         x, y,
                         x + properties.border.left, y + properties.border.top,
-                        0, 0,
+                        epW, epH,
                         properties.border.left * uScale, properties.border.top * vScale, coordinate);
-                    drawIconTextureDouble(
+                    addIconTextureDouble(t,
                         x, y + height - properties.border.bottom,
                         x + properties.border.left, y + height,
-                        0, innerBottom * vScale,
+                        epW, innerBottom * vScale,
                         properties.border.left * uScale, (innerBottom + properties.border.bottom) * vScale, coordinate);
 
-                    drawIconTextureDouble(
+                    addIconTextureDouble(t,
                         x + width - properties.border.right, y,
                         x + width, y + properties.border.top,
-                        innerRight * uScale, 0,
+                        innerRight * uScale, epH,
                         (innerRight + properties.border.right) * uScale, properties.border.top * uScale, coordinate);
-                    drawIconTextureDouble(
+                    addIconTextureDouble(t,
                         x + width - properties.border.right, y + height - properties.border.bottom,
                         x + width, y + height,
                         innerRight * uScale, innerBottom * vScale,
@@ -744,47 +707,56 @@ public class Gui
                 }
             }
         } else {
-            drawIconTextureDouble(x, y, x + width, y + height, 0, 0, coordinate.width, coordinate.height, coordinate);
+            addIconTextureDouble(t, x, y, x + width, y + height, epW, epH, coordinate.width - epW, coordinate.height - epH, coordinate);
         }
     }
 
-    public void drawIconTexture(final int x0, final int y0, final int x1, final int y1, final int u0, final int v0, final int u1, final int v1, final IconCoordinate coordinate) {
+    public void drawGuiIconDouble(final double x, final double y, final double width, final double height, final @NotNull IconCoordinate coordinate) {
         coordinate.parentAtlas.bind();
+        final TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads();
+        addGuiIconDouble(t, x, y, width, height, coordinate);
+        t.draw();
+    }
 
-        final double realU0 = coordinate.getSubIconU(u0 /((double)coordinate.width));
-        final double realU1 = coordinate.getSubIconU(u1 /((double)coordinate.width));
-        final double realV0 = coordinate.getSubIconV(v0 /((double)coordinate.height));
-        final double realV1 = coordinate.getSubIconV(v1 /((double)coordinate.height));
-
-//        System.out.printf("%s, %s, %s, %s\n", realU0, realU1, realV0, realV1);
+    public void addIconTexture(@NotNull TessellatorGeneral t, final int x0, final int y0, final int x1, final int y1, final int u0, final int v0, final int u1, final int v1, final @NotNull IconCoordinate coordinate) {
+        final double realU0 = coordinate.getSubIconU(u0 / ((double) coordinate.width));
+        final double realU1 = coordinate.getSubIconU(u1 / ((double) coordinate.width));
+        final double realV0 = coordinate.getSubIconV(v0 / ((double) coordinate.height));
+        final double realV1 = coordinate.getSubIconV(v1 / ((double) coordinate.height));
 
-        final Tessellator t = Tessellator.instance;
-        t.startDrawingQuads();
         t.addVertexWithUV(x0, y1, this.zLevel, realU0, realV1);
         t.addVertexWithUV(x1, y1, this.zLevel, realU1, realV1);
         t.addVertexWithUV(x1, y0, this.zLevel, realU1, realV0);
         t.addVertexWithUV(x0, y0, this.zLevel, realU0, realV0);
-        t.draw();
     }
 
-    public void drawIconTextureDouble(final double x0, final double y0, final double x1, final double y1, final double u0, final double v0, final double u1, final double v1, final IconCoordinate coordinate) {
+    public void drawIconTexture(final int x0, final int y0, final int x1, final int y1, final int u0, final int v0, final int u1, final int v1, final @NotNull IconCoordinate coordinate) {
         coordinate.parentAtlas.bind();
+        final TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads();
+        addIconTexture(t, x0, y0, x1, y1, u0, v0, u1, v1, coordinate);
+        t.draw();
+    }
 
-        final double realU0 = coordinate.getSubIconU(u0 /((double)coordinate.width));
-        final double realU1 = coordinate.getSubIconU(u1 /((double)coordinate.width));
-        final double realV0 = coordinate.getSubIconV(v0 /((double)coordinate.height));
-        final double realV1 = coordinate.getSubIconV(v1 /((double)coordinate.height));
-
-//        System.out.printf("%s, %s, %s, %s\n", realU0, realU1, realV0, realV1);
+    public void addIconTextureDouble(@NotNull TessellatorGeneral t, final double x0, final double y0, final double x1, final double y1, final double u0, final double v0, final double u1, final double v1, final @NotNull IconCoordinate coordinate) {
+        final double realU0 = coordinate.getSubIconU(u0 / ((double) coordinate.width));
+        final double realU1 = coordinate.getSubIconU(u1 / ((double) coordinate.width));
+        final double realV0 = coordinate.getSubIconV(v0 / ((double) coordinate.height));
+        final double realV1 = coordinate.getSubIconV(v1 / ((double) coordinate.height));
 
-        final Tessellator t = Tessellator.instance;
-        t.startDrawingQuads();
         t.addVertexWithUV(x0, y1, this.zLevel, realU0, realV1);
         t.addVertexWithUV(x1, y1, this.zLevel, realU1, realV1);
         t.addVertexWithUV(x1, y0, this.zLevel, realU1, realV0);
         t.addVertexWithUV(x0, y0, this.zLevel, realU0, realV0);
+    }
+
+    public void drawIconTextureDouble(final double x0, final double y0, final double x1, final double y1, final double u0, final double v0, final double u1, final double v1, final @NotNull IconCoordinate coordinate) {
+        coordinate.parentAtlas.bind();
+        final TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads();
+        addIconTextureDouble(t, x0, y0, x1, y1, u0, v0, u1, v1, coordinate);
         t.draw();
     }
 
-    public float zLevel;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
index 7bd5e1000..92f4bf44c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
@@ -1,17 +1,17 @@
 package net.minecraft.client.gui;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.Option;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.util.helper.Time;
 
 public class HeldItemTooltipElement extends Gui {
 
-	private Minecraft mc;
+	private final Minecraft mc;
 	
 	private int lastItemID;
 	private int lastSelectedItem;
@@ -36,13 +36,13 @@ public class HeldItemTooltipElement extends Gui {
 			int id = getItemID(item);
 			int i = mc.thePlayer.inventory.getCurrentItemIndex();
 			
-			if(id != lastItemID || i != lastSelectedItem) {
+			if(id != this.lastItemID || i != this.lastSelectedItem) {
 				updateString(item);
-				
-				time = displayTime;
-				
-				lastItemID = id;
-				lastSelectedItem = i;
+
+                this.time = this.displayTime;
+
+                this.lastItemID = id;
+                this.lastSelectedItem = i;
 			}
 		}
 		
@@ -55,13 +55,13 @@ public class HeldItemTooltipElement extends Gui {
 			int id = getItemID(item);
 			int i = mc.thePlayer.inventory.getCurrentItemIndex();
 
-			if(id != lastItemID || i != lastSelectedItem) {
+			if(id != this.lastItemID || i != this.lastSelectedItem) {
 				updateString(item);
 
-				time = displayTime;
+                this.time = this.displayTime;
 
-				lastItemID = id;
-				lastSelectedItem = i;
+                this.lastItemID = id;
+                this.lastSelectedItem = i;
 			}
 		}
 
@@ -70,7 +70,7 @@ public class HeldItemTooltipElement extends Gui {
 	
 	private void updateString(ItemStack item) {
 		if(item == null) {
-			string = null;
+            this.string = null;
 			return;
 		}
 		
@@ -79,7 +79,7 @@ public class HeldItemTooltipElement extends Gui {
 	}
 	
 	public void setOptionNameAndValueString(Option<?> option) {
-		setString(option.getDisplayStringName() + ": " + mc.gameSettings.getDisplayString(option));
+		setString(option.getDisplayStringName() + ": " + this.mc.gameSettings.getDisplayString(option));
 	}
 	
 	public void setString(String string) {
@@ -90,28 +90,28 @@ public class HeldItemTooltipElement extends Gui {
 		this.string = string;
 		this.color = color;
 		
-		this.time = displayTime;
+		this.time = this.displayTime;
 	}
 	
 	public void render(Minecraft mc, int width, int height, int screenPadding) {
 		render(mc, width/2, height - 50 - screenPadding);
 	}
 	public void render(Minecraft mc, int x, int y){
-		if(string == null) return;
-		if(time < 0.0) {
+		if(this.string == null) return;
+		if(this.time < 0.0) {
 			return;
 		}
 
 		double alpha;
 
-		if (time < fadeTime) {
-			alpha = time / fadeTime;
+		if (this.time < this.fadeTime) {
+			alpha = this.time / this.fadeTime;
 		} else {
 			alpha = 1.0;
 		}
 
 		if(!mc.isGamePaused) {
-			time -= Time.delta;
+            this.time -= Time.delta;
 		}
 
 		int a = (int) (alpha * 255);
@@ -119,18 +119,18 @@ public class HeldItemTooltipElement extends Gui {
 			return;
 		}
 
-		int rgb = (color & 0x00FFFFFF) | (a << 24);
+		int rgb = (this.color & 0x00FFFFFF) | (a << 24);
 
 		if(a < 255) {
-			glEnable(GL_BLEND);
-			glDisable(GL_ALPHA_TEST);
-			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+			GLRenderer.enableState(State.BLEND);
+			GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+//			glDisable(GL_ALPHA_TEST);
 		}
 
-		mc.font.renderCentered(Tessellator.instance, this.string, x, y).setShadow().setColor(rgb).call();
+		mc.font.renderCentered(this.string, x, y).setShadow().setColor(rgb).call();
 
-		glDisable(GL_BLEND);
-		glEnable(GL_ALPHA_TEST);
+		GLRenderer.disableState(State.BLEND);
+//		glEnable(GL_ALPHA_TEST);
 	}
 	
 	private int getItemID(ItemStack stack) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java b/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
index efeda51d5..db32b7bfc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
@@ -1,140 +1,125 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.OptionToggleable;
 
 public class IntegerSliderElement extends ButtonElement {
 
-	public int sliderValue;
-	public boolean dragging;
-	public boolean renderText = true;
-	private OptionToggleable<?> option;
-
-	public IconCoordinate backgroundTexture;
-
-	public IntegerSliderElement(int id, int xPosition, int yPosition, OptionToggleable<?> option) {
-		this(id, xPosition, yPosition, 150, 20, option);
-	}
-
-	public IntegerSliderElement(int id, int xPosition, int yPosition, int width, int height, OptionToggleable<?> option) {
-		super(id, xPosition, yPosition, width, height, option.getDisplayStringValue());
-		
-		this.dragging = false;
-		this.option = option;
-		this.sliderValue = option.getValueIndex();
-		displayString = option.getDisplayStringValue();
-	}
-
-	@Override
-	protected void setDefaultTextures() {
-		backgroundTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_background");
-		defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider");
-		hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_highlighted");
-		disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_disabled");
-	}
-
-	private int getSliderWidth()
-	{
-		return 8;
-	}
-
-	@Override
-	public void mouseDragged(Minecraft mc, int mouseX, int mouseY) {
-		if(!visible) {
-			return;
-		}
-		int sliderWidth = getSliderWidth();
-		int maxValue = option.size() - 1;
-		if(dragging) {
-			int segments = maxValue;
-			float percentage = (float) (mouseX - (xPosition + 4) - (width / (2 * segments))) / (float) (width - sliderWidth);
-			if(percentage > 1.0f)
-				percentage = 1.0f;
-			if(percentage < 0.0f)
-				percentage = 0.0f;
-			sliderValue = (int) Math.ceil(segments * percentage);
-			option.setValueWithIndex(sliderValue);
-			displayString = option.getDisplayStringValue();
-		}
-		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-	}
-
-	@Override
-	public void drawButton(Minecraft mc, int mouseX, int mouseY) {
-		if (!visible) return;
-
-		boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
-		int state = getButtonState(mouseOver);
-
-		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-
-		IconCoordinate tex;
-		switch (state) {
-			case STATE_DISABLED:
-				tex = disabledTexture;
-				break;
-			case STATE_HOVERED:
-				tex = hoveredTexture;
-				break;
-			case STATE_DEFAULT:
-			default:
-				tex = defaultTexture;
-		}
-
-		// Draw background
-		drawGuiIcon(xPosition, yPosition, width, height, backgroundTexture);
-
-		// Draw foreground
-		int sliderWidth = getSliderWidth();
-		int maxValue = option.size() - 1;
-		drawGuiIcon(xPosition + (int) ((sliderValue / (float) maxValue) * (float) (width - sliderWidth)), yPosition, sliderWidth, height, tex);
-
-		mouseDragged(mc, mouseX, mouseY);
-
-		int textColor;
-		switch (state) {
-			case 0:
-				textColor = 0xA0A0A0;
-				break;
-			case 1:
-				textColor = 0xE0E0E0;
-				break;
-			default:
-				textColor = 0xFFFFA0;
-				break;
-		}
-
-		if (this.renderText) {
-			drawStringCenteredShadow(mc.font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
-		}
-	}
-
-	@Override
-	public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY) {
-		if(super.mouseClicked(mc, mouseX, mouseY)) {
-			int segments = option.size() - 1;
-			float percentage = (float) (mouseX - (xPosition + 4) - (width / (2 * segments))) / (float) (width - 8);
-			if(percentage > 1.0f)
-				percentage = 1.0f;
-			if(percentage < 0.0f)
-				percentage = 0.0f;
-			sliderValue = (int) Math.ceil(segments * percentage);
-			option.setValueWithIndex(sliderValue);
-			displayString = option.getDisplayStringValue();
-			dragging = true;
-			return true;
-		} else {
-			return false;
-		}
-	}
-
-	@Override
-	public void mouseReleased(int mouseX, int mouseY) {
-		dragging = false;
-		displayString = option.getDisplayString();
-	}
+    public int sliderValue;
+    public boolean dragging;
+    public boolean renderText = true;
+    private final OptionToggleable<?> option;
+
+    public IconCoordinate backgroundTexture;
+
+    public IntegerSliderElement(int id, int xPosition, int yPosition, OptionToggleable<?> option) {
+        this(id, xPosition, yPosition, 150, 20, option);
+    }
+
+    public IntegerSliderElement(int id, int xPosition, int yPosition, int width, int height, OptionToggleable<?> option) {
+        super(id, xPosition, yPosition, width, height, option.getDisplayStringValue());
+
+        this.dragging = false;
+        this.option = option;
+        this.sliderValue = option.getValueIndex();
+        this.displayString = option.getDisplayStringValue();
+    }
+
+    @Override
+    protected void setDefaultTextures() {
+        this.backgroundTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_background");
+        this.defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider");
+        this.hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_highlighted");
+        this.disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_disabled");
+    }
+
+    private int getSliderWidth() {
+        return 8;
+    }
+
+    @Override
+    public void mouseDragged(Minecraft mc, int mouseX, int mouseY) {
+        if (!this.visible) {
+            return;
+        }
+        int sliderWidth = getSliderWidth();
+        int maxValue = this.option.size() - 1;
+        if (this.dragging) {
+            int segments = maxValue;
+            float percentage = (float) (mouseX - (this.xPosition + 4) - (this.width / (2 * segments))) / (float) (this.width - sliderWidth);
+            if (percentage > 1.0f)
+                percentage = 1.0f;
+            if (percentage < 0.0f)
+                percentage = 0.0f;
+            this.sliderValue = (int) Math.ceil(segments * percentage);
+            this.option.setValueWithIndex(this.sliderValue);
+            this.displayString = this.option.getDisplayStringValue();
+        }
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+    }
+
+    @Override
+    public void drawButton(Minecraft mc, int mouseX, int mouseY) {
+        if (!this.visible) return;
+
+        boolean mouseOver = mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
+        int state = getButtonState(mouseOver);
+
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+
+        IconCoordinate tex = switch (state) {
+            case STATE_DISABLED -> this.disabledTexture;
+            case STATE_HOVERED -> this.hoveredTexture;
+            default -> this.defaultTexture;
+        };
+
+        // Draw background
+        drawGuiIcon(this.xPosition, this.yPosition, this.width, this.height, this.backgroundTexture);
+
+        // Draw foreground
+        int sliderWidth = getSliderWidth();
+        int maxValue = this.option.size() - 1;
+        drawGuiIcon(this.xPosition + (int) ((this.sliderValue / (float) maxValue) * (float) (this.width - sliderWidth)), this.yPosition, sliderWidth, this.height, tex);
+
+        mouseDragged(mc, mouseX, mouseY);
+
+        int textColor = switch (state) {
+            case 0 -> 0xA0A0A0;
+            case 1 -> 0xE0E0E0;
+            default -> 0xFFFFA0;
+        };
+
+        if (this.renderText) {
+            drawStringCenteredShadow(mc.font, this.displayString, this.xPosition + this.width / 2, this.yPosition + (this.height - 8) / 2, textColor);
+        }
+    }
+
+    @Override
+    public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY) {
+        if (super.mouseClicked(mc, mouseX, mouseY)) {
+            int segments = this.option.size() - 1;
+            float percentage = (float) (mouseX - (this.xPosition + 4) - (this.width / (2 * segments))) / (float) (this.width - 8);
+            if (percentage > 1.0f)
+                percentage = 1.0f;
+            if (percentage < 0.0f)
+                percentage = 0.0f;
+            this.sliderValue = (int) Math.ceil(segments * percentage);
+            this.option.setValueWithIndex(this.sliderValue);
+            this.displayString = this.option.getDisplayStringValue();
+            this.dragging = true;
+            return true;
+        } else {
+            return false;
+        }
+    }
+
+    @Override
+    public void mouseReleased(int mouseX, int mouseY) {
+        this.dragging = false;
+        this.displayString = this.option.getDisplayString();
+    }
 }
